//MISO   D50 Arduino Mega
//SCK    D52 Arduino Mega
//MOSI   D51 Arduino Mega
#include <SPI.h>
#include <Wire.h>
#include <FT_VM800P43_50.h>
FT800IMPL_SPI FTImpl(FT_CS_PIN, FT_PDN_PIN, FT_INT_PIN);
sTagXY sTagxy;

#define FT_INT_PIN  8
#define FT_CS_PIN   9
#define FT_PDN_PIN  10

#define enc0PinA 3    //------------enkoder osi X  
#define enc0PinB 2
#define enc2PinA  21 //------------enkoder osi Z
#define enc2PinB  20

#define Estop  A7 //wejscie przycisk stopu
#define LED    A6  // lampka aktywnego stopu wyjscie 5V

volatile  long enc0Pos  , enc2Pos = 0;
float wynikX , wynikZ = 0;
int dotyk = 0;
int tagval ;
long Aold = 0;
long Bnew = 0;

float Skok_mm1 = 10;    //  skok sruby mm dla osi X
float Skok_mm3 = 10 ;  //    skok sruby mm dla osi Z

float Imp1 = 2048;    // liczba impulsow enkodera 1/obr
float Imp3 = 1000;   //  liczba impulsow enkodera 3/obr

void setup()
{
  Imp1 *= 4;       //  wykrywa zmiany enkodera1
  Imp3 *= 4;      //  wykrywa zmiany enkodera 3

  FTImpl.Init(FT_DISPLAY_RESOLUTION);
  FTImpl.Write(REG_PWM_DUTY, 90);// podswietlenie wyswietlacza min 0-128 max
  FTImpl.SetDisplayEnablePin(FT_DISPENABLE_PIN);
  FTImpl.DisplayOn();
  FTImpl.Cmd_Calibrate(0);
  FTImpl.DLStart();

  pinMode(A0, OUTPUT);  //start /stop
  pinMode(A2, OUTPUT);  //chlodziwo on/off
  pinMode(A7, INPUT_PULLUP); // przycisk awaryjny Estop
  pinMode(A6 , OUTPUT );  //LED E-stop

  pinMode(enc0PinA, INPUT_PULLUP);
  pinMode(enc0PinB, INPUT_PULLUP);
  pinMode(enc2PinA, INPUT_PULLUP);
  pinMode(enc2PinB, INPUT_PULLUP);
  //LOW   przerwanie wywołane zostanie, gdy pin będzie miał stan niski
  // HIGH  przerwanie wywołane zostanie, gdy pin będzie miał stan wysoki
  //  CHANGE  przerwanie wywołane zostanie, gdy stan pinu zmieni się
  //  FALLING   przerwanie wywołane zostanie, gdy stan pinu zmieni się z wysokiego na niski
  //  RISING  przerwanie wywołane zostanie, gdy stan pinu zmieni się z niskiego na wysoki
  attachInterrupt(0, Enc0A, CHANGE ); // 1 enkoder
  attachInterrupt(1, Enc0B, CHANGE);
  attachInterrupt(2, Enc2A, CHANGE); //3 enkoder
  attachInterrupt(3, Enc2B, CHANGE);
}
void loop()
{

  wynikX =  enc0Pos / Imp1 * Skok_mm1 ; //os X
  wynikZ = enc2Pos / Imp3 * Skok_mm3 ; //os Z
  ekran (wynikX , wynikZ );


  if (3 == dotyk ) {
    wynikX = wynikX / 2;
    enc0Pos = enc0Pos / 2;
    delay (800);
  }
  if (4 == dotyk  ) {
    wynikZ = wynikZ / 2;
    enc2Pos = enc2Pos / 2;
    delay (800);
  }

}
void ekran  ( float wynikX , float wynikZ )
{
  FTImpl.GetTagXY(sTagxy);
  tagval = sTagxy.tag;
  dotyk = tagval;

  char printbuf1[30];
  sprintf(printbuf1, "");
  dtostrf(wynikX, 6, 4, printbuf1);

  char printbuf3[30];
  sprintf(printbuf3, "");
  dtostrf(wynikZ, 6, 4, printbuf3);


  FTImpl.DLStart();
  FTImpl.ClearColorRGB(1, 1, 1);
  FTImpl.Clear(1, 1, 1);
  //////////////////////////////////////////////////////////////////////////  kolor ekranu
  FTImpl.Cmd_Gradient(375, 101, 0xFFFF7F, 384, 390, 0xFFFF7F);
  FTImpl.Cmd_FGColor(0x4F2F4F);

  FTImpl.Cmd_Button(5, 20, 80, 60, 31, 0, "X");
  FTImpl.Cmd_Button(5, 110, 80, 60, 31, 0, "Z");

  FTImpl.ColorRGB(5, 5, 5);// czarne cyfry odczytu
  FTImpl.Cmd_Text(130, 20, 31, 0, printbuf1);  // X odczyt
  FTImpl.Cmd_Text(130, 110, 31, 0, printbuf3); //Z odczyt

  FTImpl.Tag(1); // zerowanie X
  FTImpl.Cmd_FGColor(0x8E2323);
  FTImpl.ColorRGB(255, 255, 255);
  FTImpl.Cmd_Button(325, 20, 60, 50, 23, 0, "X=0");
  if (1 == dotyk ) {
    FTImpl.Cmd_FGColor(0x00FF00);
    FTImpl.ColorRGB(5, 5, 5);
    FTImpl.Cmd_Button(325, 20, 60, 50, 23, 0, "X=0");
    wynikX = 0;
    enc0Pos = 0;
    delay (200);
  }
  FTImpl.Tag(2);     // zerowanie Z
  FTImpl.Cmd_FGColor(0x8E2323);
  FTImpl.ColorRGB(255, 255, 255);
  FTImpl.Cmd_Button(325, 110, 60, 50, 28, 0, "Z=0");
  if (2 == dotyk  ) {
    FTImpl.Cmd_FGColor(0x00FF00);
    FTImpl.ColorRGB(5, 5, 5);
    FTImpl.Cmd_Button(325, 110, 60, 50, 28, 0, "Z=0");
    wynikZ = 0;
    enc2Pos = 0;
    delay (200);
  }



  FTImpl.Tag(3);
  FTImpl.Cmd_FGColor(0x8E2323);
  FTImpl.ColorRGB(255, 255, 255);
  FTImpl.Cmd_Button(400, 20, 60, 50, 28, 0, "X/2");
  if (3 == dotyk ) {
    FTImpl.Cmd_FGColor(0x00FF00);
    FTImpl.ColorRGB(5, 5, 5);
    FTImpl.Cmd_Button(400, 20, 60, 50, 28, 0, "X/2");
    delay (800);
  }

  FTImpl.Tag(4);
  FTImpl.Cmd_FGColor(0x8E2323);
  FTImpl.ColorRGB(255, 255, 255);
  FTImpl.Cmd_Button(400, 110, 60, 50, 28, 0, "Z/2");
  if (4 == dotyk  ) {
    FTImpl.Cmd_FGColor(0x00FF00);
    FTImpl.ColorRGB(5, 5, 5);
    FTImpl.Cmd_Button(400, 110, 60, 50, 28, 0, "Z/2");
    delay (800);
  }
  FTImpl.Tag(5);
  FTImpl.Cmd_FGColor(0x00FF00); //zielony
  FTImpl.ColorRGB(0, 0, 0);
  FTImpl.Cmd_Button(15, 210, 200, 58, 28, 0, "START");
  if (5 == dotyk, HIGH && (digitalRead(A0) == LOW  )) {
    FTImpl.Cmd_FGColor(0xFF0000);//czerwony
    FTImpl.Cmd_Button(15, 210, 200, 58, 28, 0, "STOP");
  }
  if (digitalRead (A7) == LOW   ) {  /// E-stop
    digitalWrite(A0, LOW);
  }
  else if (  5 == dotyk ) {
    digitalWrite(A0, !(digitalRead(A0 ))); // wlaczenie 5v na A0 do sterowania przekaznikiem START/STOP
    delay(500);
  }
  FTImpl.Tag(6);
  FTImpl.Cmd_FGColor(0x00FF00); // zielony
  FTImpl.Cmd_Button(260, 210, 200, 58, 28, 0, "WODA ON");
  if (5 == dotyk, HIGH && (digitalRead(A2) == LOW  )) {
    FTImpl.Cmd_FGColor(0x5555FF);      //niebieski
    FTImpl.Cmd_Button(260, 210, 200, 58, 28, 0, "WODA OFF");
  }
  if (digitalRead (A7) == LOW   ) {  // E- stop
    digitalWrite(A2, LOW);
  }
  else if (6 == dotyk) {
    digitalWrite(A2, !digitalRead(A2)) ;   //właczenie 5 v na A2 do sterowania przekaznikiem chlodziwo
    delay(500);
  }

  if (digitalRead (A7) == LOW   ) {
    digitalWrite (A6 , HIGH);      //led e-stop on
    delay(200);
    digitalWrite (A6 , LOW);     // led e -stop off
    delay(200);
    FTImpl.Cmd_FGColor(0xFF0000); // E-Stop czerwone
    FTImpl.ColorRGB(0, 0, 0); // czarne litery
    FTImpl.Cmd_Button(105, 5, 200, 190, 31, 0, "E - STOP");  // czerwony E-STOP
  }
  else if (digitalRead (A7) == HIGH  ) {
    digitalWrite (A6 , LOW);
  }
  FTImpl.DLEnd(); // Zamykamy liste wyswietlania
  FTImpl.Finish(); // Renderujemu liste i czekamy na ukonczenie

}

// Interrupt A enkoder 1
void Enc0A() {

  Bnew^Aold ? enc0Pos++ : enc0Pos--;
  Aold = digitalRead(enc0PinA);
}

// Interrupt B
void Enc0B() {
  Bnew = digitalRead(enc0PinB);
  Bnew^Aold ? enc0Pos++ : enc0Pos--;
}
// Interrupt A enkoder 2
void Enc2A() {

  Bnew^Aold ? enc2Pos++ : enc2Pos--;
  Aold = digitalRead(enc2PinA);
}

// Interrupt B
void Enc2B() {
  Bnew = digitalRead(enc2PinB);
  Bnew^Aold ? enc2Pos++ : enc2Pos--;
}
